#include <math.h>
#include "D:\Dokumenty\Skola\Vejska\statniceING\Diplomka\Matlab\implementace_do_uPc\regulace.h"
#include "D:\Dokumenty\Skola\Vejska\statniceING\Diplomka\Matlab\implementace_do_uPc\parametry.h"


float PI_reg(float pozadovana, float skutecna, float Kp, float Ti, float yMin, float yMax, float *sum, float dt)
{
    float y;
    float err;
    
    err=pozadovana - skutecna;
    
    y = Kp*err + sum[0];
    
    if (y > yMax) return yMax;
    if (y < yMin) return yMin;
    
    sum[0]=sum[0]+err*(Kp/Ti)*dt;
    
    return y;
}


void feedforward(float Id_w, float Iq_w, float omega, float Rs, float Ld, float Lq, float Psi, float *Udq_FF)
{
    Udq_FF[0]=Rs*Id_w - 2*omega*Lq*Iq_w;
    Udq_FF[1]=Rs*Iq_w + 2*omega*(Ld*Id_w+Psi);
}

void soucet_PI_FF(float Ud_PI, float Uq_PI, float Ud_FF, float Uq_FF, float uMin, float uMax, float *Udq)
{
    Udq[0]=Ud_PI + Ud_FF;
    if (Udq[0] > uMax) Udq[0]=uMax;
    if (Udq[0] < uMin) Udq[0]=uMin;
    
    Udq[1]=Uq_PI + Uq_FF;
    if (Udq[1] > uMax) Udq[1]=uMax;
    if (Udq[1] < uMin) Udq[1]=uMin;
}

void Urm_filter(float Ual, float Ube, float Kf, float *Uf)
{
    Uf[0]=(4.9585e-3)*sqrt(Ual*Ual+Ube*Ube);

    Uf[1]=Uf[1] + Kf*(Uf[0]-Uf[1]);
}

float omezovac_Iq(float Ismax, float Id_w)
{
  float Iqmax;
  Iqmax=sqrt(Ismax*Ismax - Id_w*Id_w);
  return Iqmax;
}

void soucet_IqP_IqOmega(float IqP, float IqOmega, float Iqmax, float *Idq_w)
{ 
  Idq_w[1]=IqP + IqOmega;
  
  if (Idq_w[1]>Iqmax) Idq_w[1]=Iqmax;
  if (Idq_w[1]<(-Iqmax)) Idq_w[1]=-Iqmax;
}
        




